<?php /*
Plugin Name: BBCode_bar
Version: 0.9
Description: Allow use BBCode for comments and descriptions. / Permet d'utiliser du BBCode pour les commentaires et les descriptions.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=140
Author: Atadilo
Author URI: http://www.phpwebgallery.net
*/
	global $conf;
  
	if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
	
	// 
	if ( (!isset($conf['bbcode_bar'])) or (substr_count($conf['bbcode_bar'] , ',') != 17) ){
		//  $conf['bbcode_bar'] contient des 0 ou 1 qui indique si l'utilisation des certaines balise est auoris ou non.
		// Dans l'ordre :
		// 	Paragraph		Paragraphe
		// 	Bold			Gras		
		// 	Italic			Italique
		// 	Underline		Soulign
		// 	Strikethrough	Barr
		// 	Center		Centr
		// 	Right			Droite
		//	Ulist			List
		// 	Olist			Liste ordonn
		// 	Quotes		Citation
		// 	Images		Images
		// 	URL			Adresse
		// 	Email			Ml
		// 	Size			Taille
		// 	Colours		Couleurs
		// 	Preview		Prvisualiser
		$conf['bbcode_bar'] = '1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,plugins/bbcode_bar/icon';
		include_once('plugins/bbcode_bar/maintain.inc.php');
		plugin_install();
	}

	// Init
	add_event_handler('init', 'set_bbcode_bar_render', 50, 1 );	
	// Fonction d'initalisation
	function set_bbcode_bar_render () {	
		global $template;	
		
		// Include le fichier de lang
		//include(PHPWG_PLUGINS_PATH.'bbcode_bar/language/'.get_default_language().'/plugin.lang.php');
		include(get_language_filepath('plugin.lang.php', dirname(__FILE__).'/'));
					
		include_once(PHPWG_PLUGINS_PATH.'bbcode_bar/bbcode_bar.inc.php');
		
		// un peu de pub.
		$template->assign_block_vars( 
		'theme', 
		array( 'ABOUT' => '<a href="http://phpwebgallery.net/ext/extension_view.php?eid=140">Use BBCode_bar.</a>',));
		
		// On enleve le 'render_comment_content' pour le remplacer par un qui va traiter le BBCode
		remove_event_handler('render_comment_content', 'parse_comment_content' );
		add_event_handler('render_comment_content', 'ParseComment', 50, 1 );
		
		// Ajout du renderer des catgories
		add_event_handler('render_cat_description', 'htmlspecialchars');
		add_event_handler('render_cat_description', 'ParseComment', 50, 1 );
		
		// Ajout du renderer des descriptions des lments
		add_event_handler('render_element_description', 'htmlspecialchars');
		add_event_handler('render_element_description', 'set_bbcode_bar_render', 50, 1 );
		
		
	}
	
	// Permettre le Preview du commentaire
	function textareaPreview ()	{
		global $page, $picture, $template, $conf, $user;
		
		if (isset($_GET['action'])) {
			switch ($_GET['action']) {
				case 'preview' :
				{
					if (isset($_GET['content']))
					{
						$template->assign_block_vars (
							'comments.comment',
							array(
					          'COMMENT_AUTHOR' => $user['username'],
					          'COMMENT_DATE' => "",
					          'COMMENT' => trigger_event('render_comment_content',$_GET['content']),
					          )
						);
						
						$template->merge_block_vars('comments.add_comment',
						array(
						  'KEY' => $_GET[key],
						  'CONTENT' => $_GET['content']
						));
					}					
				}
			}
		}
	}
	add_event_handler('loc_end_picture', 'textareaPreview');
	
	// La fonction ne sera appel que lors du chargement de 'picture.tpl' 
	add_event_handler('loc_end_picture', 'set_bbcode_bar_comments', 40, 1 );
	// Fonction qui ajoute la BBCode bar
	function set_bbcode_bar_comments($content) {
		global $template, $conf;
		
		$conf_bbcode_bar = explode("," , $conf['bbcode_bar']);
		
		$tlp_handle = 'picture';
		$old = '<textarea name="content" rows="5" cols="80">';
		$new = '{BBCODE_BAR}';
		
		$template->loadfile($tlp_handle);
		$template->uncompiled_code[$tlp_handle] = str_replace($old, $new.$old, $template->uncompiled_code[$tlp_handle]);
		
		$template->assign_block_vars( 'BBCode_bar_button',array() );
		$template->assign_vars( array('formname' => 'addComment') );
		$template->assign_vars( array('textareaname' => 'content') );		
			
		// Ajout du bouton Preview
		if ($conf_bbcode_bar[16] == 1) {
		
			$old = '{lang:submit}">';
			$after = ' &nbsp; <input class="submit" type="button" value="{lang:preview}" onclick="preview( \'addComment\',\'content\' )" >';
		
			$template->loadfile($tlp_handle);
			$template->uncompiled_code[$tlp_handle] = str_replace($old, $old.$after, $template->uncompiled_code[$tlp_handle]);
		}	
		
		commonInitBAr ();
		
	}
		
	add_event_handler('loc_end_cat_modify', 'set_bbcode_bar_DescriptionCAT');		
	function set_bbcode_bar_DescriptionCAT($content) {
		global $template;
		
		$tlp_handle = 'categories';
		$old = '<textarea cols="50" rows="5" name="comment" class="description">';
		$new = '{BBCODE_BAR}';
		
		$template->loadfile($tlp_handle);
		$template->uncompiled_code[$tlp_handle] = str_replace($old, $new.$old, $template->uncompiled_code[$tlp_handle]);
		
		$template->assign_block_vars( 'BBCode_bar_button',array() );
		$template->assign_vars( array('formname' => 'catModify') );
		$template->assign_vars( array('textareaname' => 'comment') );		
				
		commonInitBAr ();
	}
	
	add_event_handler('loc_end_picture_modify', 'set_bbcode_bar_DescriptionPIC');
	function set_bbcode_bar_DescriptionPIC($content) {
		global $template;
		
		$tlp_handle = 'picture_modify';
		$old = '<textarea name="description" class="description">';
		$new = '{BBCODE_BAR}';
		
		$template->loadfile($tlp_handle);
		$template->uncompiled_code[$tlp_handle] = str_replace($old, $new.$old, $template->uncompiled_code[$tlp_handle]);
							
		$template->assign_block_vars( 'BBCode_bar_button',array() );
		$template->assign_vars( array('formname' => 'properties') );
		$template->assign_vars( array('textareaname' => 'description') );		
		
		commonInitBAr ();
		
	}
	
	add_event_handler('loc_begin_picture', 'set_bbcode_bar_css', 50, 1);
	add_event_handler('loc_begin_cat_modify', 'set_bbcode_bar_css', 50, 1);
	add_event_handler('loc_begin_picture_modify', 'set_bbcode_bar_css', 50, 1);
	function set_bbcode_bar_css ( $content ){
		global $template;
		// la feuille de style
	    $content = '<link rel="stylesheet" type="text/css" href="'.PHPWG_PLUGINS_PATH.'bbcode_bar/bbcode_bar.css" >';		
	    $template->assign_block_vars( 'head_element', array( 'CONTENT' => $content, ) );	
		
		remove_event_handler('loc_end_picture', 'set_smiliessupport_page' );
	}
	
	function commonInitBAr () {
		global $conf, $template, $pwg_loaded_plugins;
		
		$conf_bbcode_bar = explode("," , $conf['bbcode_bar']);		
		
		// Ajout de la barre d'icones
		$template->set_filenames( array('bbcode_bar'=> PHPWG_PLUGINS_PATH.'bbcode_bar/bbcode_bar.tpl') );
				
		if ($conf_bbcode_bar[0]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_00',array() );
		if ($conf_bbcode_bar[1]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_01',array() );			
		if ($conf_bbcode_bar[2]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_02',array() );
		if ($conf_bbcode_bar[3]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_03',array() );
		if ($conf_bbcode_bar[4]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_04',array() );
		if ($conf_bbcode_bar[5]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_05',array() );
		if ($conf_bbcode_bar[6]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_06',array() );
		if ($conf_bbcode_bar[7]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_07',array() );
		if ($conf_bbcode_bar[8]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_08',array() );
		if ($conf_bbcode_bar[9]  == 1) $template->assign_block_vars( 'BBCode_bar_button.button_09',array() );
		if ($conf_bbcode_bar[10] == 1) $template->assign_block_vars( 'BBCode_bar_button.button_10',array() );
		if ($conf_bbcode_bar[11] == 1) $template->assign_block_vars( 'BBCode_bar_button.button_11',array() );
		if ($conf_bbcode_bar[12] == 1) $template->assign_block_vars( 'BBCode_bar_button.button_12',array() );
		if ($conf_bbcode_bar[13] == 1) $template->assign_block_vars( 'BBCode_bar_button.button_13',array() );
		if ($conf_bbcode_bar[14] == 1) $template->assign_block_vars( 'BBCode_bar_button.button_14',array() );
		if ($conf_bbcode_bar[15] == 1) $template->assign_block_vars( 'BBCode_bar_button.button_15',array() );
		
		
		if ( isset($pwg_loaded_plugins['SmiliesSupport']) ){
			$template->assign_block_vars( 'BBCode_bar_button.SmiliesSupport',array() );	
			addSmiliesTable();
		}
		
		$template->assign_vars( array('repicon' => $conf_bbcode_bar[17]) );
		
		$template->assign_var_from_handle( 'BBCODE_BAR', 'bbcode_bar');
	}

	// Ajout du menu d'admin
	function bbcode_bar_admin_menu($menu) {
	    array_push($menu,
	        array('NAME' => 'BBCode_Bar',
	            'URL' => get_admin_plugin_menu_link(dirname(__FILE__) . '/bbcode_bar_admin.php')
	            )
	        );
	    return $menu;
	}
	add_event_handler('get_admin_plugin_menu_links', 'bbcode_bar_admin_menu');
	
		
?>
